//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
#include "direct.h"
#include "stdio.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "AP_PDF2TIFF_OCX"
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------


void __fastcall TForm1::FormCreate(TObject *Sender)
{
    //To create the com object.
    m_pAxPdf2Tiff = new TAxPdf2Tiff(this);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormDestroy(TObject *Sender)
{
    //To free the com object.
    if( m_pAxPdf2Tiff != NULL ){
        delete m_pAxPdf2Tiff;
    }
}
//---------------------------------------------------------------------------
//Demo1 - To convert all pages of the pdf document.
void __fastcall TForm1::btnDemo1Click(TObject *Sender)
{
    DWORD iStartTick,iEndTick;

    AnsiString sFileName = "sample.pdf";
    iStartTick = GetTickCount();

    //Open pdf document and creating a converter.
    long nHandle = m_pAxPdf2Tiff->apOpen((WideString)sFileName, NULL, NULL);
    switch( nHandle ){
     case ERR_OVER_MAXTHREADS:{ ShowMessage("Over the limit amount of threads,please waiting!"); return; };
     case ERR_FILE_UNEXIST:{ ShowMessage("Source pdf file unexist!"); return; };
     case ERR_FILE_DAMAGED:{ ShowMessage("Source pdf file damaged!"); return; };
     case ERR_FILE_RESTRICTED:{ ShowMessage("Source pdf file restricted!"); return; };
    }

    //Setting proerties.
    m_pAxPdf2Tiff->sOutDirectory = "./demo1";
    m_pAxPdf2Tiff->iMultiPages = TRUE;   //To generate multipages tiff.
    m_pAxPdf2Tiff->iCompression = AP_TIFF_COMPRESSION_LZW;
    m_pAxPdf2Tiff->iXDPI = 130;
    m_pAxPdf2Tiff->iYDPI = 130;

    //To convert all pages of the pdf document.
    long iPageCount = m_pAxPdf2Tiff->apGetPageCount(nHandle);
    for(int iPageNo = 1; iPageNo <= iPageCount; iPageNo++){
       m_pAxPdf2Tiff->apConvertPage(nHandle,iPageNo);

       //Setting conversion's progress.
       m_ProgressBar->Position = (long)((iPageNo)*1.0/iPageCount*100);
    }

    //Close pdf document and destory the converter.
    m_pAxPdf2Tiff->apClose(nHandle);

    iEndTick = GetTickCount();
    ShowMessage("Conversion successful,it passed "+IntToStr(iEndTick-iStartTick)+"ms!");
}
//---------------------------------------------------------------------------
//demo2 - To convert appointed pdf pages of the pdf document to memory stream.
void __fastcall TForm1::btnDemo2Click(TObject *Sender)
{
    DWORD iStartTick,iEndTick;
    DWORD m_Pages[6] = {1, 3, 6, 8, 9, 11};

    AnsiString sFileName = "sample.pdf";
    iStartTick = GetTickCount();

    //Open pdf document and creating a converter.
    long nHandle = m_pAxPdf2Tiff->apOpen((WideString)sFileName, NULL, NULL);
    switch( nHandle ){
     case ERR_OVER_MAXTHREADS:{ ShowMessage("Over the limit amount of threads,please waiting!"); return; };
     case ERR_FILE_UNEXIST:{ ShowMessage("Source pdf file unexist!"); return; };
     case ERR_FILE_DAMAGED:{ ShowMessage("Source pdf file damaged!"); return; };
     case ERR_FILE_RESTRICTED:{ ShowMessage("Source pdf file restricted!"); return; };
    }

    //Setting proerties.
    m_pAxPdf2Tiff->iCompression = AP_TIFF_COMPRESSION_LZW;
    m_pAxPdf2Tiff->iXDPI = 110;
    m_pAxPdf2Tiff->iYDPI = 110;
    m_pAxPdf2Tiff->iXDimensions = 995;
    m_pAxPdf2Tiff->iYDimensions = 1287;

    //To convert the appointed pages of the pdf document.
    long iPageCount = 6;
    for(int iPos = 0; iPos <= iPageCount - 1; iPos++){
       //You can save image stream to database, to file, or to others, etc.
       //The "pImageStream" is a pointer which point to the memory stream of an image.
       m_pAxPdf2Tiff->apConvertPageToStream(nHandle,m_Pages[iPos]);
       BYTE *pImageStream = (BYTE *)m_pAxPdf2Tiff->iStreamHandle;

       //Here,the stream is saved to file.
       if( pImageStream != NULL && m_pAxPdf2Tiff->iStreamSize > 0 ){
            char sImgFile[256];
            _mkdir("./demo2");
            sprintf(sImgFile,"./demo2/myimg_%02d.tif",m_Pages[iPos]);

            FILE *pFile = fopen(sImgFile,"wb");
            if( pFile != NULL ){
                fwrite(pImageStream,1,m_pAxPdf2Tiff->iStreamSize,pFile);
                fclose(pFile);
            }
       }

       //Setting conversion's progress.
       m_ProgressBar->Position = (long)((iPos+1)*1.0/iPageCount*100);
    }

    //Close pdf document and destory the converter.
    m_pAxPdf2Tiff->apClose(nHandle);

    iEndTick = GetTickCount();
    ShowMessage("Conversion successful,it passed "+IntToStr(iEndTick-iStartTick)+"ms!");
}
//---------------------------------------------------------------------------
